#ifndef SOCKETSERVEUR_H
#define SOCKETSERVEUR_H

#include "FamillesAdresse.h"
#include "FamillesProtocole.h"
#include "Port.h"
#include "Adresse.h"
#include "incopiable.h"
#include <cstdlib>
#include <memory>

class socket_conversation;

class socket_serveur
   : Incopiable
{
   class Impl;
   using ptr_type = std::unique_ptr<Impl>;
   ptr_type impl;
public:
   socket_serveur(const Port&);
   socket_serveur(const Port&, FamilleAdresse, FamilleProtocole);
   socket_serveur(socket_serveur && );
   ~socket_serveur();
   socket_conversation accepter();
   bool est_bloquant() const;
   void rendre_bloquant();
   void rendre_non_bloquant();
   Port port() const;
};

#endif
